-- TODO add drawhelpers table, so drawhelpers.centerscreens etc?
function centerscreen(w,h, int)
	local scale = min(screen.w/w,screen.h/h)
	if int then scale = floor(scale) end
	local x = floor((screen.w-w*scale)*.5)
	local y = floor((screen.h-h*scale)*.5)
	lg.translate(x,y)
	lg.scale(scale)
	return x,y,scale
end


function load_palette(file)
	local palette = {}
	local pal = love.image.newImageData(file)
	for y = 0,pal:getHeight()-1 do
		palette[y] = {}
		for x = 0,pal:getWidth()-1 do
			local r,g,b,a = pal:getPixel(x, y)
			palette[y][x] = {r,g,b}
		end
	end
	return palette
end
function apply_pallete(palette, index)
	for i = 1,4 do
		shader.palette:send("col" .. i, palette[0][i-1])
		shader.palette:send("rep" .. i, palette[index][i-1])
	end
end


function smooth(smoothfall, smoothslide, blocksize)
	lg.translate(smoothslide*blocksize, -smoothfall*blocksize)
end

function drawpiece(xoff, yoff, r, mino, block, tex, ghost)
	for x=0,3 do for y = 0,3 do
		local m = mino*64 + r*16 + y*4 + x
		if block.quad[m] then
			lg.draw(
				tex,
				block.quad[m],
				((x + xoff)%style.board.w)*block.size,
				(y+yoff)*block.size
			)
		end
	end end
end