require "/games/minobueno/spinny"
game = {}

game.state = "playing"

-- reset on new game (see game.reload)
--==============================================================================
local level = 0
local bag = {}

-- timing
local timer = 0 -- this timer is generally used as a countdown for switching the game.state
local droptimer = 0
local das = 0
local lockdelay = 0
local softdelay = 0
local lockdelay_soft = 0
local softlock = false
local last_held_right = false

local smoothfall = 0
local smoothslide = 0

local harddrop = false
local wallhit = false

-- scoring related
local score = 0
local cells_softdropped = 0
local combo = 0

local to_clear = {}; for i = 0,style.board.h-1 do to_clear[i] = false end
local held = {
	mino = -1,
	x = 0,
	y = 0,
	r = 0,
	hold = -1,
	has_used_hold = false,
}
-- next piece, -1 is dummy
local next = {-1, -1, -1, -1, -1, -1}
local count = {
	lines = 0,
	pieces = {0,0,0,0,0,0,0},
}

local dropblur = {y = 0, timer = -1, held = {mino = -1,x=0,y=0,r=0}}

-- permanent values
--==============================================================================

-- level difficulty, in frames per cell
-- TODO make sure they're not off-by-1 when checked
local levels = {
	nes = {
		48,43,38,33,28,
		23,18,13, 8, 6,
		 5, 5, 5, 4, 4,
		 4, 3, 3, 3, 2,
		 2, 2, 2, 2, 2,
		 2, 2, 2, 2, 1
	},
	gameboy = {
		53,49,45,41,37,
		33,28,22,17,11,
		10, 9, 8, 7, 6,
		 6, 5, 5, 4, 4,3
	},
	-- TODO tengen levels
	tengen = {
		40,40,40,40,40,
		40,40,40,40,40,
		40,40,40,40,40,
		40,40,40,40,40,
	},
	sega_easy = {
		48,32,24,18,
		14,12,10,8,
		 6, 4,12,10,
		 8, 6, 4, 2,
	},
	sega_normal = {
		48,24,18,15,
		12,10, 8, 6,
		 4, 2,10, 8,
		 6, 4, 2, 1,
	},
	sega_hard = {
		40,20,16,12,
		10, 8, 6, 4,
		 2, 1,10, 8,
		 6, 4, 2, 1,
	},
	sega_hardest = {
		30,15,12,10,
		 8, 6, 4, 2,
		 1, 1, 8, 6,
		 4, 2, 1, 1,
	},
	cylinder = {
		100,80,60,40,20
	},
	debug = {
		99999999999
	},
}

local getLevel = function()
	return levels[settings.conf.levels][min(level + 1, #levels[settings.conf.levels])]
end

-- offset for how each rotation, compared to SRS
-- TODO make local again somehow, maybe game.rot_system?
-- menu needs it too, though...

rot_system = { -- global because spinny.lua needs it
	srs = {
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- I
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- J
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- L
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- O
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- S
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- T
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- Z
	},
	bps = {
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- I
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- J
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- L
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- O
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- S
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- T
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- Z
	},
	nes = {
		{{ 0, 1},{ 0, 0},{ 0, 0},{ 1, 0}}, -- I
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- J
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- L
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- O
		{{ 0, 1},{ 0, 0},{ 0, 0},{ 1, 0}}, -- S
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- T
		{{ 0, 1},{ 0, 0},{ 0, 0},{ 1, 0}}, -- Z
	},
	electronika = { -- probably?
		{{ 0, 0},{ 0, 0},{ 0,-1},{ 1, 0}}, -- I
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- J
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- L
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- O
		{{ 0, 1},{ 0, 0},{ 0, 0},{ 1, 0}}, -- S
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- T
		{{ 0, 1},{ 0, 0},{ 0, 0},{ 1, 0}}, -- Z
	},
	gameboy = {
		{{ 0, 1},{-1, 0},{ 0, 0},{ 0, 0}}, -- I
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- J
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- L
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- O
		{{ 0, 1},{-1, 0},{ 0, 0},{ 0, 0}}, -- S
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- T
		{{ 0, 1},{-1, 0},{ 0, 0},{ 0, 0}}, -- Z
	},
	tengen = {
		{{ 0,-1},{-1, 0},{ 0,-2},{ 0, 0}}, -- I
		{{ 0, 0},{-1, 0},{ 0,-1},{ 0, 0}}, -- J
		{{ 0, 0},{-1, 0},{ 0,-1},{ 0, 0}}, -- L
		{{-1,-1},{-1,-1},{-1,-1},{-1,-1}}, -- O
		{{ 0, 0},{-1, 0},{ 0,-1},{ 0, 0}}, -- S
		{{ 0, 0},{-1, 0},{ 0,-1},{ 0, 0}}, -- T
		{{ 0, 0},{-1, 0},{ 0,-1},{ 0, 0}}, -- Z
	},
	sega = {
		{{ 0, 0},{ 0, 0},{ 0,-1},{ 1, 0}}, -- I
		{{ 0, 1},{ 0, 0},{ 0, 0},{ 0, 0}}, -- J
		{{ 0, 1},{ 0, 0},{ 0, 0},{ 0, 0}}, -- L
		{{ 0, 0},{ 0, 0},{ 0, 0},{ 0, 0}}, -- O
		{{ 0, 1},{-1, 0},{ 0, 0},{ 0, 0}}, -- S
		{{ 0, 1},{ 0, 0},{ 0, 0},{ 0, 0}}, -- T
		{{ 0, 1},{ 0, 0},{ 0, 0},{ 1, 0}}, -- Z
	},
}

local rot_offset = {
	srs = {0,0,0,0,0,0,0},
	bps = {2,2,2,2,2,2,2},
	nes = {2,2,2,2,2,2,2},
	electronika = {2,2,2,2,2,2,2},
	gameboy = {2,2,2,2,2,2,2},
	tengen = {2,2,2,2,2,2,2},
	sega = {2,2,2,2,2,2,2},
}

-- end permanent values
--==============================================================================

local block = {}
local board = {}
local rs = {} -- "rotation system"

local function reset_mino_pos()
	if not style.board.wrap then
		held.x = style.spawn_offset[held.mino+1][1]
	end
	held.y = style.spawn_offset[held.mino+1][2]
	held.r = rot_offset[settings.conf.rot_system][held.mino+1] -- TODO check these

	lockdelay_soft = settings.conf.lockdelay_soft
	droptimer = getLevel()
	cells_softdropped = 0
	if settings.conf.softlock then softlock = true end
end

local function generate_piece()
	if settings.conf.randomizer == "modern" or settings.conf.randomizer == "small" then
		local b = 0
		if #bag ~= 0 then
			b = bag[1]
			table.remove(bag, 1)
			held.mino = next[1]
			table.remove(next,1)
			next[#next+1] = b
		end
		if #bag == 0 then
			local t = {0,0,1,1,2,2,3,3,4,4,5,5,6,6}
			if settings.conf.randomizer == "small" then
				t = {0,1,2,3,4,5,6}
			end
			for i = #t,2,-1 do
				a = rand(i)
				t[i],t[a] = t[a],t[i]
			end
			bag = t
		end

	elseif settings.conf.randomizer == "nes" then
		local b = rand(0,6)
		if b == next[1] then b = rand(0,6) end
		held.mino = next[1]
		next[1] = b
	end

	-- place mino on board with proper offset
	if held.mino ~= -1 then
		count.pieces[held.mino+1] = count.pieces[held.mino+1] + 1
		reset_mino_pos()
	else
		generate_piece()
	end
end

game.reload = {

	gfx = function()
		-- TODO make this local or something
		-- TODO also this doesn't need done on every gfx reset
		drawpieces = love.filesystem.load("games/minobueno/pieces/" .. settings.conf.piece_gfx .. "/main.lua")()
		block.size = 8
		block.quad= {}
		rs = {} -- "Rotation System"
		local rot = love.image.newImageData("/games/minobueno/tilemap.png")
		for p = 0,6 do for r = 0,3 do
			for x = 0,3 do for y = 0,3 do
				local col = rot:getPixel(r * 4 + x, p * 4 + y)
				local m = p*64 + r*16 + y*4 + x

				if col > 0.5 then
					rs[m] = true
					block.quad[m] = lg.newQuad(
						(x+r*4)*8,
						(y+p*4)*8,
						8, 8,
						128, 224
					)
				else
					rs[m] = false
					block.quad[m] = false
				end
			end end
		end end
		dropblur = {y = 0, timer = -1, held = {mino = -1,x=0,y=0,r=0}}
		redraw.game = true

	end,

	sfx = function()
		stopsfx()
		stopstylesfx()
		-- load normal SFX
		sfx = {}
		local folder = "/games/minobueno/sfx/" .. settings.conf.piece_sfx
		local files = love.filesystem.getDirectoryItems(folder)
		for i,k in pairs(files) do
			sfx[k:sub(1,-5)] = love.audio.newSource(folder .. "/"..k, "static")
		end

		-- load style's optional extra SFX, with optional looping
		style.sfx = {}
		folder = "/games/minobueno/style/" .. settings.style .. "/sfx/"
		if exists(folder) then
			local files = love.filesystem.getDirectoryItems(folder)
			for i,k in pairs(files) do
				local name = ""
				local looping = false
				if k:sub(-9,-5) == ".loop" then
					name = k:sub(1,-10)
					looping = true
				else
					name = k:sub(1,-5)
				end
				style.sfx[name] = love.audio.newSource(folder .. "/"..k, "static")
				if looping then style.sfx[name]:setLooping(true) end
			end
		end
	end,

	board = function()
		-- reset all values...
		-- TODO see if there's any way to avoid having to define
		-- all these variables here as well as the top of this file
		level = 0
		bag = {}
		-- timing
		timer = 0 -- this timer is generally used as a countdown for switching the game.state
		droptimer = 0
		das = 0
		lockdelay = 0
		softdelay = 0
		lockdelay_soft = 0
		softlock = false
		last_held_right = false
		-- scoring related
		score = 0
		cells_softdropped = 0
		combo = 0

		to_clear = {}; for i = 0,style.board.h-1 do to_clear[i] = false end
		held = {
			mino = -1,
			x = 0,
			y = 0,
			r = 0,
			hold = -1,
			has_used_hold = false,
		}
		-- next piece, -1 is dummy
		next = {-1, -1, -1, -1, -1, -1}
		count = {
			lines = 0,
			pieces = {0,0,0,0,0,0,0},
		}

		board = {}
		for x = 0,style.board.w-1 do
			board[x] = {}
			for y = -4,style.board.h-1 do
				board[x][y] = -1
			end
		end
		generate_piece()
	end,

	style = function()
		game.canvas = lg.newCanvas(style.size.w, style.size.h)
		redraw.game = true
		if style.init then style.init({level = level}) end
	end,

	music = function()
		if style.conf.album and style.conf.song then
			settings.music.album = style.conf.album
			settings.music.song = style.conf.song
			updatemusic(nil,nil,true)
		end
	end,

}

local function check_col(x2,y2,r2)
	x2 = x2 or 0
	y2 = y2 or 0
	r2 = r2 or 0
	for x=0,3 do
		for y = 0,3 do
			local m = rs[held.mino*64+((held.r+r2)%4)*16+y*4+x]
			if m then
				-- board edges
				if not style.board.wrap then
					if x + x2 + held.x > style.board.w-1 then return true end
					if x + x2 + held.x < 0 then return true end
				end
				if y + y2 + held.y > style.board.h-1 then return true end
				if settings.conf.allow_above_field then
					if y + y2 + held.y < -3 then return true end
				else
					if y + y2 + held.y < 0 then return true end
				end
				if style.board.wrap then
					if board[(x+x2+held.x)%style.board.w][y+y2+held.y] ~= -1 then return true end
				else
					if board[x+x2+held.x][y+y2+held.y] ~= -1 then return true end
				end
			end
		end
	end
end

local function gameover()
	game.state = "gameover"
	placemino()
	timer = style.gameover_time
	stopmusic()
	if style.gameover then style.gameover() end
end

local function new_mino()
	held.mino = -1
	held.has_used_hold = false
	generate_piece()

	if check_col() and settings.conf.gameover_check == "oncollision" then
		gameover(); return
	end
end

-- check for fast music
local function checkmusic()
	if game.state ~= "gameover" then
		if settings.music then
			local isfast = false
			for x = 0, style.board.w-1 do for y = 0,5 do
				if board[x][y] ~= -1 then
					updatemusic(nil, true)
					return
				end
			end end
		end
		updatemusic(nil, false)
	end
end

local function move(x,y,r)
	if game.state == "playing" then
		x = x or 0
		y = y or 0
		r = r or 0
		if r ~= 0 then
			-- rotation system offset
			local offset_current = rot_system[settings.conf.rot_system][held.mino+1][held.r+1]
			local offset_next = rot_system[settings.conf.rot_system][held.mino+1][(held.r+r)%4+1]

			-- wall kicks
			local try = {}
			if settings.conf.kicks == "permissive" then
				try = {
					{0,0},			-- none
					{0,1},			-- down
					{-1,1},{1,1},	-- down + (left,right)
					{0,-1},			-- up
					{-1,0},{1,0}	-- left,right
				}
				-- extra kick if mino is long... is this how its suppored to work?
				if held.mino == 0 then
					try[#try+1] = {2,0}
					try[#try+1] = {-2,0}
					try[#try+1] = {0,2}
					try[#try+1] = {0,-2}
				end
			elseif settings.conf.kicks == "atari" then
				try = {
					{0,0},
					{-1,0},
				}
			elseif settings.conf.kicks == "none" then
				try = {
					{0,0}
				}
			end
			for i in ipairs(try) do
				local x2 = try[i][1] + offset_next[1] - offset_current[1]
				local y2 = try[i][2] + offset_next[2] - offset_current[2]
				if not check_col(x2+x,y2+y,r) then
					held.x = held.x + x2
					held.y = held.y + y2
					held.r = (held.r + r)%4
					-- reset droptimer when piece moves up
					-- only applies if the game has wallkicks but not infinite spin
					-- TODO add non-infinite spin that does not let the piece
					-- being moved by rotation trigger a droptimer reset
					if y ~= 0
					-- actual infinite spin
					or (
						settings.conf.lockreset == "infinity" and
						check_col(0,1)
					)
					then
						droptimer = getLevel()
						lockdelay = settings.conf.lockdelay
					end
					spinny.timer = r
					playsfx("spin")
					return true
				end
			end
		else
			if not check_col(x,y) then
				held.x = held.x + x
				held.y = held.y + y
				if y == 0 then playsfx("move") end
				if x ~= 0 then smoothslide = x * settings.conf.smoothslide end
				return true
			end
		end
	end
	return false
end

function placemino()
	local lowest_block = 0
	for x = 0,3 do
		for y = 0,3 do
			local m = held.mino*64 + held.r*16 + y*4 + x
			-- delete pieces above playfield, optionally
			local j = -4;
			if settings.conf.delete_above_field then j = 0 end

			if m ~= -1 and held.y + y >= j and rs[m] then
				if style.board.wrap then
					board[(held.x + x)%style.board.w][held.y + y] = m
				else
					board[held.x + x][held.y + y] = m
				end
				-- this placemino function is also run after a gameover to place the last block
				-- so it would be an infinite loop without this check
				if game.state ~= "gameover" then
					if held.y+y < 0 and settings.conf.gameover_check == "overtop" then
						gameover()
					else -- return lowest block
						lowest_block = max(lowest_block, held.y + y)
					end
				end
			end
		end
	end
	return lowest_block
end

function game.update(dt)
	if style.update ~= nil then style.update(dt, {held = held}) end
	spinny.update(dt)
	dropblur.timer = dropblur.timer + 1
	if game.state == "playing" then
		if isdown("soft") and not softlock and settings.conf.softdrop then
			if softdelay == -1 then
				droptimer = math.min(droptimer, settings.conf.softdrop_period)
			elseif softdelay <= 0 then
				droptimer = 0
				softdelay = -1
			else
				softdelay = softdelay - 1
			end
		else
			softdelay = settings.conf.softdrop_delay
			cells_softdropped = 0
		end

		if not isdown("soft") and not isdown("left") and not isdown("right") then
			softlock = false
		elseif (isdown("left") or isdown("right")) and settings.conf.softlock then
			softlock = true
		end

		if isdown("right") ~= isdown("left")
		and not (isdown("left") and last_held_right)
		and not (isdown("right") and not last_held_right)
		then
			das = das - 1
			last_held_right = isdown("right")
			if das <= 0 and not (isdown("soft") and settings.conf.softlock) then
				das = settings.conf.das_period
				local dir = -1;if isdown("right") then dir = 1 end
				if not move(dir,0) and not wallhit then
					playsfx("wall"); wallhit = true
				end
			end
		else
			wallhit = false
			das = settings.conf.das_delay
			last_held_right = isdown("right")
		end

		droptimer = droptimer - 1
		if droptimer <= 0 then
			-- move the mino down, if it doesn't go, lock it into place
			if not move(0,1) then
				if not isdown("soft") then
					lockdelay_soft = settings.conf.lockdelay_soft
				end
				if lockdelay > 0 and lockdelay_soft > 0 then
					lockdelay = lockdelay - 1
					lockdelay_soft = lockdelay_soft - 1
				else -- place mino blocks on the board
					local lowest_block = placemino()

					if softdelay == -1 then cells_softdropped = cells_softdropped + 1 end

					if settings.conf.scoring == "nes" or settings.conf.scoring == "modern" or settings.conf.scoring == "gameboy" then
						score = score + cells_softdropped
					elseif settings.conf.scoring == "tengen" then
						local dropscore = (level + (style.board.h - lowest_block)) * (level+1)
						if cells_softdropped >= 3 then dropscore = dropscore * 2 end
						dropscore = min(dropscore, 999)
						score = score + dropscore
						if style.dropscore then
							style.dropscore(lowest_block, dropscore)
						end
					end

					checkmusic()

					-- sfx
					if not harddrop then
						if cells_softdropped == 0 then playsfx("lock") end
					else
						if not playsfx("harddrop") then
							if not playsfx("place") then
								if not playsfx("collide") then
									playsfx("lock")
								end
							end
						end
					end
					playsfx("next" .. next[1]) -- lockjaw sfx

					-- check for clear
					local lines = 0
					for line = 0,style.board.h-1 do
						local isclear = true
						for x = 0,style.board.w-1 do
							if board[x][line] == -1 then
								isclear = false
								break
							end
						end
						if isclear then
							to_clear[line] = true
							game.state = "clearing"
							timer = settings.conf.clear_delay
							lines = lines + 1
						end
					end

					count.lastclear = lines

					if lines > 0 then combo = combo + 1 else combo = 0 end

					if lines > 0 and lines < 4 then
						playsfx("clear")
					elseif lines == 4 then
						if not playsfx("fourlines") then playsfx("clear") end
					elseif not harddrop then
						playsfx("place")
					end

					-- don't do ARE if we're clearing lines
					if settings.conf.ARE > 0 then
						if game.state == "playing" then
							game.state = "ARE"
							timer = settings.conf.ARE
						end
					else
						new_mino()
					end
				end
			else
				if check_col(0,1) and (not settings.conf.smoothfall or settings.conf.smoothfall == "late") then
					playsfx("collide")
				end
				droptimer = droptimer + getLevel()
				lockdelay = settings.conf.lockdelay
				if softdelay == -1 then
					cells_softdropped = cells_softdropped + 1
				end
			end
		end

		if settings.conf.smoothfall == "late" then
			smoothfall = droptimer/getLevel() - 1
			if droptimer <= 0 or check_col(0,1) then
				smoothfall = 0
			end
		elseif settings.conf.smoothfall == "early" then
			smoothfall = droptimer/getLevel()
			if droptimer <= 0 or check_col(0,-1) then
				if smoothfall == 0 then playsfx("collide") end
				smoothfall = 0
			end
		else
			smoothfall = 0
		end

		if smoothslide > 0 then
			smoothslide = smoothslide - 1
		elseif smoothslide < 0 then
			smoothslide = smoothslide + 1
		end

		harddrop = false

	elseif game.state == "clearing" then
		timer = timer - 1
		-- remove cleared lines
		if timer <= 0 then
			playsfx("clear_after")
			-- WARNING this is because styles with ARE do not have ARE enabled
			-- after line clears, but this could change if a style does this!
			if settings.conf.ARE > 0 then new_mino() end

			game.state = "playing"

			if style.start_clear then board = style.start_clear(to_clear, board) end

			-- remove cleared lines
			for i in ipairs(to_clear) do
				if to_clear[i] then
					for y=i,-2,-1 do for x=0,style.board.w-1 do
						board[x][y] = board[x][y-1]
					end end
				end
			end
			for i = 0,style.board.h-1 do to_clear[i] = false end

			-- count score, lines, level up
			count.lines = count.lines + count.lastclear
			local lastlevel = level

			if settings.conf.scoring == "minobueno" then
				level = floor(count.lines/10)
				score = floor(score + (3^count.lastclear) * (1.5^combo) * (level + 1))
			elseif settings.conf.scoring == "nes" or settings.conf.scoring == "gameboy" then
				level = floor(count.lines/10)
				local s = 0
				if count.lastclear == 1 then
					s = 40
				elseif count.lastclear == 2 then
					s = 100
				elseif count.lastclear == 3 then
					s = 300
				elseif count.lastclear == 4 then
					s = 1200
				end
				s = s * (lastlevel + 1)
				score = score + s
			elseif settings.conf.scoring == "modern" then
				level = floor(count.lines/10)
				local s = 0
				if count.lastclear == 1 then
					s = 100
				elseif count.lastclear == 2 then
					s = 300
				elseif count.lastclear == 3 then
					s = 500
				elseif count.lastclear == 4 then
					s = 800
				end
				local c = 50 * combo * level
				score = score + s + c
			-- TODO tengen scoring
			elseif settings.conf.scoring == "tengen" then
				level = floor(count.lines/30)
				local s = 0
				if count.lastclear == 1 then
					s = 100
				elseif count.lastclear == 2 then
					s = 400
				elseif count.lastclear == 3 then
					s = 900
				elseif count.lastclear == 4 then
					s = 2500
				end
				score = score + s
			elseif settings.conf.scoring == "lockjaw" then
				level = floor(count.lines/10) -- TODO idk how lockjaw levels
				local s = 0
				if count.lastclear == 1 then
					s = 100
				elseif count.lastclear == 2 then
					s = 400
				elseif count.lastclear == 3 then
					s = 700
				elseif count.lastclear == 4 then
					s = 1200
				end
				score = score + s
				-- TODO implement back-to-back scoring
			elseif settings.conf.scoring == "cylinder" then
				level = floor(count.lines/20)
				local s = 0
				if count.lastclear == 1 then
					s = 100
				elseif count.lastclear == 2 then
					s = 400
				elseif count.lastclear == 3 then
					s = 700
				elseif count.lastclear == 4 then
					s = 1200
				end
				score = score + s
			end

			if lastlevel ~= level then
				--TODO why was this done again...?
				--~ sfx.place:stop()
				--~ sfx.clear:stop()
				--~ sfx.fourlines:stop()
				stopsfx()
				playsfx("levelup")
			end
			-- tell the game style lines were cleared
			if style.line_clear then style.line_clear(level) end
		end
		checkmusic()
	elseif game.state == "ARE" then
		timer = timer - 1
		if timer <= 0 then
			game.state = "playing"
			new_mino()
		end
	elseif game.state == "gameover" then
		timer = timer - 1
		if timer <= 0 then
			state = "menu"
			stopsfx()
			stopstylesfx()
		end
	end
end

function game.draw(redraw)
	if redraw then
		-- get position of ghost piece
		local ghost = 0
		for i = 1,22 do
			if check_col(0, i, 0) then ghost = i-1;break end
		end

		-- for pieces that shade as they're about to set
		local dropshadow = 1
		if check_col(0,1,0) then dropshadow = lockdelay/settings.conf.lockdelay end
		local ss = -smoothslide/settings.conf.smoothslide
		if settings.conf.smoothslide == 0 then ss = 0 end
		style.draw({
			pieces = count.pieces,
			score = score,
			lines = count.lines,
			lastclear = count.lastclear,
			timer = timer,
			level = level,
			held = held,
			board = board,
			block = block,
			ghost = ghost,
			next = next,
			to_clear = to_clear,
			smoothfall = smoothfall,
			smoothslide = ss,
			dropshadow = dropshadow,
			dropblur = dropblur
			},
			game.canvas
		)
		lg.setCanvas()
	end
	local w,h = style.size.w, style.size.h
	if settings.gfx.aspectcorrect and  style.size_aspectcorrect then
		w,h = style.size_aspectcorrect.w, style.size_aspectcorrect.h
	end
	return game.canvas, w,h
end

function game.input(k)
	if k == "pause" then
		state = "menu"
		if game.state == "gameover" then
			stopsfx()
			stopstylesfx()
		else
			pausesfx()
			pausestylesfx()
		end
	end

	if game.state ~= "gameover" then
		if k == "right"
		and not (isdown("soft") and settings.conf.softlock)
		then
			if isdown("right") ~= isdown("left") then
				move(1,0)
			end

		elseif k == "left"
		and not (isdown("soft") and settings.conf.softlock)
		then
			if isdown("right") ~= isdown("left") then
				move(-1,0)
			end
		-- TODO why is this isdown check needed
		elseif k == "soft" and not (isdown("soft") and settings.conf.softlock) then
			droptimer = 0
			lockdelay = 0

		elseif k == "rotcw" then
			if not move(0,0, 1) then playsfx("no") end

		elseif k == "rotccw" then
			if not move(0,0,-1) then playsfx("no") end

		elseif k == "hard" and settings.conf.harddrop then
			local i = 0
			while true do
				if not move(0,1) then
					droptimer = 0
					lockdelay = 0
					smoothfall = 0
					smoothslide = 0
					if settings.conf.scoring == "modern" then score = score + i*2 end
					harddrop = true
					dropblur.timer = 0
					dropblur.y = i
					dropblur.held = {mino = held.mino,x=held.x,y=held.y,r=held.r}
					break
				else
					i = i + 1
				end
			end

		elseif k == "hold" then
			if settings.conf.hold and not held.has_used_hold then
				playsfx("hold")
				held.has_used_hold = true
				held.hold, held.mino = held.mino, held.hold
				if held.mino == -1 then
					generate_piece()
				else
					reset_mino_pos()
				end
			end

		--~ -- DEBUG
		--~ elseif k == "l" then
			--~ count.lines = count.lines + 10

		--~ -- DEBUG
		--~ elseif k == "x" then
			--~ for x = 0,style.board.w-1 do for y = 0,style.board.h-1 do
				--~ board[x][y] = -1
			--~ end end

		--~ -- DEBUG
		--~ elseif k == "1" or k == "2" or k == "3" or k == "4"
			--~ or k == "5" or k == "6" or k == "7"  then

			--~ if isdown("lshift") then
				--~ next[1] = k - 1
			--~ else
				--~ held.mino = k - 1
			--~ end

		--elseif k == "backspace" then
			--love.event.quit()
			--new_mino()
		end
	end
end