local folder = "games/minobueno/pieces/lockjaw/"
local tex = lg.newImage(folder .. "tex.png")
local tex_ghost = lg.newImage(folder .. "ghost.png")

return {
	board = function(board, block)
		for x = 0,style.board.w - 1 do for y = -4,style.board.h - 1 do
			local tile = board[x][y]
			if tile ~= -1 then
				lg.draw(tex, block.quad[tile], x*block.size, y*block.size)
			end
		end end
	end,
	pieces = function(vars, state)
		local held = vars.held
		local block = vars.block

		if settings.conf.ghost then
			drawpiece(held.x, held.y + vars.ghost, held.r, held.mino, block, tex_ghost)
		end

		-- draw motion blur
		if vars.dropblur.timer == 1 then
			local held = vars.dropblur.held
			for y = 1,vars.dropblur.y do
				drawpiece(held.x, held.y - y, held.r, held.mino, block, tex)
			end
		end
		if state == "playing" then
			-- fancy spin rotation
			lg.push()
			smooth(vars.smoothfall, vars.smoothslide, block.size)
			if settings.conf.spinny and spinny.timer ~= 0 then
				spinny.transform(held.mino, held.x, held.y, block.size, held.r, rot_system[settings.conf.rot_system][held.mino+1])
			end

			-- draw piece
			local s = vars.dropshadow*.5+.5
			lg.setColor(s,s,s,1)
			drawpiece(held.x, held.y, held.r, held.mino, block, tex)
			lg.setColor(1,1,1,1)
			lg.pop()
		end
	end
}