local folder = "games/minobueno/pieces/st2/"
local tex = love.graphics.newImage(folder .. "tex.png")
local tex_mino = love.graphics.newImage(folder .. "tex_mino.png")
return {
	board = function(board, block)
		for x = 0,style.board.w - 1 do for y = -4,style.board.h - 1 do
			local tile = board[x][y]
			if tile ~= -1 then
				lg.draw(tex, block.quad[tile], x*block.size, y*block.size)
			end
		end end
	end,
	pieces = function(vars, state)
		local held = vars.held
		local block = vars.block

		local tex = tex_mino

		if settings.conf.ghost then
			lg.setBlendMode("add")
			drawpiece(held.x, held.y + vars.ghost, held.r, held.mino, block, tex)
			lg.setBlendMode("alpha")
		end

		smooth(vars.smoothfall, vars.smoothslide, block.size)
		-- Fancy spin rotation
		lg.push()
		if settings.conf.spinny and spinny.timer ~= 0 then
			spinny.transform(held.mino, held.x, held.y, block.size, held.r, rot_system[settings.conf.rot_system][held.mino+1])
		end

		-- Draw normal piece
		drawpiece(held.x, held.y, held.r, held.mino, block, tex)
		lg.pop()
	end
}