local folder = "games/minobueno/pieces/tengen/"
local tex = lg.newImage(folder .. "tex.png")
local tex_ghost = lg.newImage(folder .. "ghost.png")
local palette_mino = load_palette(folder.."palette_mino.png")
local palette_board = load_palette(folder.."palette_board.png")

return {
	board = function(board, block, level)
		lg.setShader(shader.palette)
		apply_pallete(palette_board, level%(#palette_board+1))
		for x = 0,style.board.w - 1 do for y = -4,style.board.h - 1 do
			local tile = board[x][y]
			if tile ~= -1 then
				lg.draw(tex, block.quad[tile], x*block.size, y*block.size)
			end
		end end
		lg.setShader()
	end,
	pieces = function(vars, state)
		local held = vars.held
		local block = vars.block
		lg.setShader(shader.palette)
		apply_pallete(palette_mino, held.mino+1)

		if settings.conf.ghost then
			drawpiece(held.x, held.y + vars.ghost, held.r, held.mino, block, tex_ghost)
		end

		smooth(vars.smoothfall, vars.smoothslide, block.size)
		-- fancy spin rotation
		lg.push()
		if settings.conf.spinny and spinny.timer ~= 0 then
			spinny.transform(held.mino, held.x, held.y, block.size, held.r, rot_system[settings.conf.rot_system][held.mino+1])
		end

		-- draw normal piece
		drawpiece(held.x, held.y, held.r, held.mino, block, tex)
		lg.setShader()
		lg.pop()
	end
}