-- spinny.lua: handles eyecandy of pieces being partially rotated
spinny = {
	timer = 0,
	-- center for rotation for srs rotation
	-- other rotation systems are corrected for automatically
	-- TODO these half-block-offsets miiiight be slightly problematic
	offset = {
		{2.0,2.0}, -- I
		{1.5,1.5}, -- J
		{1.5,1.5}, -- L
		{2.0,2.0}, -- O
		{1.5,1.5}, -- S
		{1.5,1.5}, -- T
		{1.5,1.5}, -- Z
	},

	update = function(dt)
		if spinny.timer > 0 then spinny.timer = spinny.timer + .5 end
		if spinny.timer < 0 then spinny.timer = spinny.timer - .5 end
		if abs(spinny.timer) > 2 then spinny.timer = 0 end
	end,

	transform = function(mino, minox, minoy, blocksize, rot, rotsystem)
		local r = 0
		local rs = rotsystem
		local offset = {}

		offset = {
			x=spinny.offset[mino+1][1],
			y=spinny.offset[mino+1][2],
		}
		local diffx,diffy
		if spinny.timer > 0 then -- if clockwise
			diffx = rs[rot+1][1] - rs[(rot-1)%4+1][1]
			diffy = rs[rot+1][2] - rs[(rot-1)%4+1][2]
		else                     -- if counterclockwise
			diffx = rs[rot+1][1] - rs[(rot+1)%4+1][1]
			diffy = rs[rot+1][2] - rs[(rot+1)%4+1][2]
		end

		--if spinny.timer > 0 then r = -math.pi*.25 else r = math.pi*.25 end
		local ox = (minox + offset.x)*blocksize
		local oy = (minoy + offset.y)*blocksize
		lg.translate(
			ox,
			oy
		)

		local c = 1 - (abs(spinny.timer)-1)
		lg.translate(
			-diffx*blocksize*c,
			-diffy*blocksize*c
		)

		--lg.rotate(r)
		lg.rotate((spinny.timer/2)*math.pi + math.pi)
		lg.translate(
			-ox,
			-oy
		)
	end
}