menu = {}

menu.logo = lg.newImage("menu/logo.png")
menu.bg_about = lg.newImage("menu/bg_about.png")

menu.sub = {}
menu.stack = {}
menu.stack_cursor = {0}

menu.push = function(t)
	table.insert(menu.stack, 1, t)
	table.insert(menu.stack_cursor, 1, menu.item)
	menu.sub = menu.stack[1]
	menu.item = 0
end

menu.pop = function()
	if #menu.stack > 1 then
		table.remove(menu.stack, 1)
		table.remove(menu.stack_cursor, 1)
		menu.sub = menu.stack[1]
		menu.item = menu.stack_cursor[1]
		return true
	else
		return false
	end
end

menu.set = function(t)
	menu.stack[1] = t
	menu.sub = t
end

menu.item = 0
menu.items = {}

local function resumeGame()
	if game then
		state = "game"
		resumesfx()
		resumestylesfx()
		if game.state == "gameover" then
			newgame("board")
			game.state = "playing"
		end
	end
end

menu.init = function()

	if not menu.items.main then menu.items.main = {
		tabname = "Main",
		{
			text = "Play",
			onclick = function(self)
				resumeGame()
			end
		},
		{
			text = "Restart",
			onclick = function(self)
				menu.push({{
					text = "This will end your game! Are you sure?",
					onclick = function(self)
						if self.selected == 1 then
							stopsfx()
							stopstylesfx()
							newgame("board")
							game.state = "playing"
							state = "game"
						end
						menu.pop()
					end,
					selected = 1,
					options = {"Yes", "No"},
					type = "newline",
				}})
			end
		},
		--~ {
			--~ text = "Game Mode",
			--~ init = function(self)
				--~ self.options = love.filesystem.getDirectoryItems("/games/")
				--~ self.selected = getindex(self.options, settings.game)
				--~ if not self.selected then self.selected = 1 end
				--~ settings.game = self.options[self.selected]
			--~ end,
			--~ is_highlighted = function(self)
				--~ return self.options[self.selected] ~= settings.game
			--~ end,
			--~ onclick = function(self)
				--~ local g = self.options[self.selected]
				--~ menu.push({{
					--~ text = "This will end your game! Are you sure?",
					--~ onclick = function(self)
						--~ if self.selected == 1 then
							--~ settings.game = g
							--~ newgame()
							--~ menu.init()
						--~ end
						--~ menu.pop()
					--~ end,
					--~ selected = 1,
					--~ options = {"Yes", "No"},
					--~ type = "newline",
				--~ }})
			--~ end,
			--~ options = {}
		--~ },
		{
			text = "Game Mode Settings",
			onclick = function(self)
				if game then
					menu.push(menu.items.game)
				end
			end,
		},
		--{text = "Input", onclick = function(self) menu.push(menu.items.input) end},
		{text = "Sound", onclick = function(self) menu.push(menu.items.sound) end},
		{text = "Menu Background", onclick = function(self) menu.push(menu.items.bg) end},
		{text = "Graphics options", onclick = function(self) menu.push(menu.items.graphics) end},
		{
			text = "About",
			onclick = function(self)
				menu.push({
				tabname = "About",
				{
					text = "Back",
					onclick = function(self) menu.pop() end,
					type = "about",
				}})
			end,
		},
		{
			text = "Quit",
			onclick = function(self)
				menu.push({{
					text="Are you sure you want to quit?",
					onclick = function(self)
						if self.selected == 1 then
							love.event.quit()
						else
							menu.pop()
						end
					end,
					selected = 1,
					options = {"Yes", "No"},
					type = "newline",
				}})
			end,
		}
	}
	menu.push(menu.items.main)
	end

	-- background settings
	if not menu.items.bg then menu.items.bg = {
		{text = "Back", onclick = function(self) menu.pop() end},
		{
			text = "Draw BG in game",
			init = function(self)
				if settings.gamebg then self.selected = 2 else self.selected = 1 end
			end,
			onchange = function(self)
				settings.gamebg = self.options[self.selected]
			end,
			selected = 1,
			options = {false, true},
			options_text = {"Disabled", "Enabled"},
		},
		{
			text = "Menu Background",
			init = function(self)
				self.options = love.filesystem.getDirectoryItems("menu/bg/")
				bg = love.filesystem.load("/menu/bg/" .. settings.bg .. "/main.lua")()
				bg.init()
				if bg.resize then bg.resize() end
				 -- clear background settings
				menu.items.bg = {menu.items.bg[1],menu.items.bg[2],menu.items.bg[3]}
				menu.items.bg.tabname = "Menu BG"
				-- add BG specific options
				if bg.menuitems then
					for i,k in ipairs(bg.menuitems) do
						table.insert(menu.items.bg, k)
						k.init(k)
					end
				end
				self.selected = getindex(self.options, settings.bg)
			end,
			onchange = function(self)
				settings.bg = self.options[self.selected]
				self.init(self)
				menu.set(menu.items.bg)
			end,
			selected = 1,
			options = {},
		},
	} end

	-- music menu
	if not menu.items.sound then menu.items.sound = {
		tabname = "Sound",
		{ text = "Back", onclick = function(self) menu.pop() end},
		{
			text = "Music",
			init = function(self)
				self.selected = getindex(self.options, settings.music.enabled)
			end,
			onchange = function(self)
				settings.music.enabled = self.options[self.selected]
				if settings.music.enabled then
					updatemusic(nil, nil, true)
				else
					stopmusic()
				end
			end,
			options = {true, false},
			options_text = {"Enabled", "Disabled"}
		},
		{
			text = "Autoseek",
			init = function(self)
				self.selected = getindex(self.options, settings.music.autoseek) or 1
			end,
			onchange = function(self)
				settings.music.autoseek = self.options[self.selected]
			end,
			options = {true, false},
			options_text = {"Enabled", "Disabled"},
			help = "Tries to seek to the correct place in the fast version of the music, instead of restarting. Not perfect, can crackle.",
		},
		{
			text = "SFX",
			init = function(self)
				self.selected = getindex(self.options, settings.sfx)
			end,
			onchange = function(self)
				settings.sfx = self.options[self.selected]
				if not settings.sfx then stopsfx() end
			end,
			options = {true, false},
			options_text = {"Enabled", "Disabled"}
		},
		{
			text = "Style SFX",
			init = function(self)
				self.selected = getindex(self.options, settings.stylesfx)
			end,
			onchange = function(self)
				settings.stylesfx = self.options[self.selected]
				if not settings.stylesfx then stopstylesfx() end
			end,
			options = {true, false},
			options_text = {"Enabled", "Disabled"},
			help = "Styles can have their own SFX such as game-over sounds or environment sounds like rain",
		},
		{
			text = "Album",
			init = function(self)
				self.options = love.filesystem.getDirectoryItems("/music/")
				self.selected = getindex(self.options, settings.music.album)
				if self.selected == nil then self.selected = 1 end
			end,
			onchange = function(self)
				settings.music.album = self.options[self.selected]
				menu.items.sound[7].init(menu.items.sound[7]) -- TODO this is a terrible hack, dependant on menu entry number
			end,
			selected = 1,
			options = {},
			type = "newline",
		},
		{
			text = "Song",
			update_help = function(self)
				if exists("/music/".. settings.music.album.."/"..settings.music.song.."/info.txt") then
					self.help = love.filesystem.read("/music/".. settings.music.album.."/"..settings.music.song.."/info.txt")
				else
					self.help = false
				end
			end,
			init = function(self)
				self.options = love.filesystem.getDirectoryItems("/music/" .. settings.music.album)
				self.selected = getindex(self.options, settings.music.song)
				if self.selected == false then self.selected = 1 end
				updatemusic(self.options[self.selected], nil, true)
				self.update_help(self)
			end,
			onchange = function(self)
				updatemusic(self.options[self.selected])
				self.update_help(self)
			end,
			selected = 1,
			options = {},
			type = "newline",
		},

	} end

	--graphics menu
	if not menu.items.graphics then menu.items.graphics = {
		tabname = "GFX",
		{ text = "Back", onclick = function(self) menu.pop() end},
		{
			text = "Full screen",
			init = function(self)
				if settings.gfx.fullscreen then self.selected = 2 else self.selected = 1 end
			end,
			onclick = function(self)
				settings.gfx.fullscreen = self.options[self.selected]
				if settings.gfx.fullscreen then
					love.window.setMode(lg.getWidth(), lg.getHeight(), {vsync=not settings.gfx.lowlatency, resizable=true, fullscreen=settings.gfx.fullscreen})
				else
					love.window.setMode(settings.window.w, settings.window.h, {vsync=not settings.gfx.lowlatency, resizable=true, fullscreen=settings.gfx.fullscreen})
				end
				newgame("style") -- re-runs style.init TODO find out why this is necessary
			end,
			is_highlighted = function(self)
				return self.options[self.selected] ~= settings.gfx.fullscreen
			end,
			selected = 1,
			options = {false, true},
			options_text = {"Disabled", "Enabled"},
		},
		{
			text = "CRT shader",
			init = function(self)
				self.selected = getindex(self.options, settings.gfx.crt)
				self.selected = self.selected or 1
			end,
			onchange = function(self)
				settings.gfx.crt = self.options[self.selected]
				redraw.game = true
			end,
			selected = 1,
			options = {false, true},
			options_text = {"Disabled", "Enabled"},
		},
		{
			text = "Integer scaling",
			init = function(self)
				self.selected = getindex(self.options, settings.gfx.intscale)
				self.selected = self.selected or 1
			end,
			onchange = function(self)
				settings.gfx.intscale = self.options[self.selected]
				redraw.game = true
			end,
			selected = 1,
			options = {false, true},
			options_text = {"Disabled", "Enabled"},
			help = "Pixel-perfect scaling, which will probably make the game window smaller"
		},
		{
			text = "Aspect Correct",
			init = function(self)
				self.selected = getindex(self.options, settings.gfx.aspectcorrect)
				self.selected = self.selected or 1
			end,
			onchange = function(self)
				settings.gfx.aspectcorrect = self.options[self.selected]
				redraw.game = true
			end,
			selected = 1,
			options = {true, false},
			options_text = {"Enabled", "Disabled"},
			help = "Some systems (such as the NES and SNES) have non-square pixels. This stretches them to be correct, when appropriate."
		},
		{
			text = "Pixel scaling shader",
			init = function(self)
				self.selected = getindex(self.options, settings.gfx.pixelshader)
				self.selected = self.selected or 1
			end,
			onchange = function(self)
				settings.gfx.pixelshader = self.options[self.selected]
				redraw.game = true
			end,
			selected = 1,
			options = {false, true},
			options_text = {"Disabled", "Enabled"},
			help = "Shader (known as pixellate in retroarch) that keeps pixels sharp at non-integer scales by interpolating just the pixel edges"
		},
		{
			text = "Always show FPS",
			init = function(self)
				self.selected = getindex(self.options, settings.gfx.showfps)
				self.selected = self.selected or 1
			end,
			onchange = function(self)
				settings.gfx.showfps = self.options[self.selected]
			end,
			selected = 1,
			options = {false, true},
			options_text = {"Disabled", "Enabled"},
		},
		{
			text = "Low latency mode",
			init = function(self)
				if settings.gfx.lowlatency then self.selected = 2 else self.selected = 1 end
				--error(self.selected)
			end,
			onclick = function(self)
				settings.gfx.lowlatency = self.options[self.selected]
				love.window.setMode(lg.getWidth(), lg.getHeight(), {vsync=not settings.gfx.lowlatency, resizable=true, fullscreen=settings.gfx.fullscreen})
				newgame("style") -- re-runs style.init TODO find out why this is necessary
			end,
			is_highlighted = function(self)
				return self.options[self.selected] ~= settings.gfx.lowlatency
			end,
			selected = 1,
			options = {false, true},
			options_text = {"Disabled", "Enabled"},
			help = "WARNING: This will increase CPU load a lot and disable vsync, but will reduce latency from ~120ms to ~40ms (in my tests)\nYou also want this enabled if your display is not 60Hz"
		},
	} end

	if not menu.items.game then
		-- insert game mode specific options
		if exists("games/" .. settings.game .. "/menu.lua") then
			menu.items.game = {}
			local items = love.filesystem.load("games/" .. settings.game .. "/menu.lua")()
			menu.items.game.tabname = "Game"
			for i,k in ipairs(items) do
				table.insert(menu.items.game, k)
				if k.init then k.init(k) end
			end
		end
	end

	-- run all init scripts
	for i,k in pairs(menu.items) do
		for j,l in pairs(k) do
			if l.init then l.init(l) end
		end
	end

end

menu.input = function(k)
	if k == "ok" then
		local m = menu.sub[menu.item+1]
		if m.onclick then
			m.onclick(m)
		end
	elseif k == "pause" then
		resumeGame()
	elseif k == "right" then
		local m = menu.sub[menu.item+1]
		if m.selected then
			m.selected = (m.selected) % (#m.options) + 1
		end
		if m.onchange then m.onchange(m) end
	elseif k == "left" then
		local m = menu.sub[menu.item+1]
		if m.selected then
			m.selected = (m.selected - 2) % (#m.options) + 1
		end
		if m.onchange then m.onchange(m) end
	elseif k == "up" then
		menu.item = (menu.item - 1)%(#menu.sub)
		menu.stack_cursor[1] = menu.item
	elseif k == "down" then
		menu.item = (menu.item + 1)%(#menu.sub)
		menu.stack_cursor[1] = menu.item
	elseif k == "back" then
		if not menu.pop() then -- keep in mind menu.pop gets run either way
			resumeGame()
		end
	end
end

menu.draw = function()
	lg.push()
	centerscreen(1440,1080)

	lg.draw(menu.logo,420, 16, 0, 0.5)
	if version then
		lg.print("Commit: " .. version, 400, 1040, 0, 1/fontscale)
	end

	-- print tabs
	j = 0
	for i=#menu.stack,1,-1 do
		local t = menu.stack[i].tabname
		if t then
			if j > 0 then -- tab shadow
				lg.setColor(0,0,0,1/4)
				lg.rectangle("fill", 400 + j * 128 - 128, 272, 192, 128, 16, 16, 8)
				lg.rectangle("fill", 400 + j * 128 - 4,   272, 192, 128, 16, 16, 8)
			end
			lg.setColor(0x72/0xff,0x72/0xff,0x72/0xff) -- TODO this is awful
			lg.rectangle("fill", 400 + j * 128, 272, 192, 128, 16, 16, 8)
			lg.setColor(1,1,1)
			j = j + 1
			lg.print(t, 288 + j*128, 288, 0, 1/fontscale)
		end
	end

	-- draw box
	lg.setColor(0x72/0xff,0x72/0xff,0x72/0xff) -- TODO this is awful
	lg.rectangle("fill", 400, 320, 640, 720)
	lg.setColor(1,1,1)

	-- print menu text
	local y = 0
	local is_darkline
	for i,k in ipairs(menu.sub) do
		y = y + 32

		local m = menu.sub[i]

		-- dark lines
		is_darkline = not is_darkline
		if is_darkline then
			lg.setColor(0x6a/0xff, 0x6a/0xff, 0x6a/0xff) -- TODO this is awful
			if m.type == "newline" then
				lg.rectangle("fill", 400, 320 + y, 640, 64)
			else
				lg.rectangle("fill", 400, 320 + y, 640, 32)
			end
			lg.setColor(1,1,1)
		end

		-- draw cursor
		if menu.item == i-1 then
			lg.setColor(0x54/0xff,0x89/0xff,0x98/0xff,1) -- TODO this is awful
			if m.type == "newline" then
				lg.rectangle("fill", 400, 320 + y, 640, 64)
			else
				lg.rectangle("fill", 400, 320 + y, 640, 32)
			end
			lg.setColor(1,1,1)
		end

		if m.is_highlighted and m.is_highlighted(m) then lg.setColor(1,3/4,1/4) else lg.setColor(1,1,1) end

		lg.print(k.text, 432, 320 + y, 0, 1/fontscale)


		if m.options then if #m.options > 0 then
			local text = ""
			if m.options_text then
				text = m.options_text[m.selected]
			else
				text = tostring(m.options[m.selected])
			end
			if m.type == "newline" then
				y = y + 32
				lg.setColor(0,0,0,1/4)
				lg.rectangle("fill", 480, 320 + y, 480, 32)
				lg.setColor(1,1,1)
				lg.print(text, 480, 320 + y, 0, 1/fontscale)
			else
				--lg.print(text, 800, 320 + y, 0, 2)
				lg.printf(text, 400, 320 + y, 608*fontscale, "right", 0, 1/fontscale)
			end
		end end
	end

	-- "about" page
	if menu.sub[menu.item+1].type == "about" then lg.draw(menu.bg_about, 360, 180+96) end

	-- print help text
	lg.setColor(1,1,1, 3/4)
	if menu.sub[menu.item+1] then if menu.sub[menu.item+1].help then
		lg.printf(menu.sub[menu.item+1].help, 464, 768+64, 512*fontscale, "center", 0, 1/fontscale)
	end end
	lg.setColor(1,1,1)
	lg.pop()
end

menu.resize = function(w,h)
	if bg then if bg.resize then bg.resize(w,h) end end
end