-- TODO this might cause issues with other things that use points
lg.setPointSize(1)
local points = {}
local inertia = {}
local snowcanvas = lg.newCanvas(1024,1024)
snowcanvas:setWrap("repeat", "repeat")
local quad = {}
local genquad = function()
	quad = {}
	local scale = min(screen.w/512/settings.bgsettings.scale, screen.h/512/settings.bgsettings.scale)
	local w2, h2 = screen.w*scale, screen.h*scale
	--for i = 1,depth do quad[i] = lg.newQuad(i*300, 0, w2/(i/2)/scale, h2/(i/2)/scale, 1024*scale, 1024*scale) end
	for i = 1,settings.bgsettings.depth do
		quad[i] = lg.newQuad(
			i*300, 0, -- add to X coord for some extra randomization
			w2/(2/(i*.5))/scale, h2/(2/(i*.5))/scale,
			1024*scale, 1024*scale
		)
	end
end

--local snowflakes = 256
--local depth = 4

--for i = 1,4 do quad[i] = lg.newQuad(0, 0, 1920/(i/2), 1080/(i/2), 1024, 1024) end
return {
init = function()
	local snowflakes = settings.bgsettings.snowflakes or 256
	for i = 1,snowflakes do
		table.insert(points, math.random(1,1024))
		table.insert(points, math.random(1,1024))
		table.insert(inertia, 0)
		table.insert(inertia, 0)
	end
end,
update = function(dt)
	for i = 1,#points,2 do
		inertia[i] = clamp(inertia[i] + (math.random(1,256)/256 - 0.5)*dt*30, -1, 1)
		inertia[i+1] = clamp(inertia[i+1] + (math.random(1,32)/32 - 0.5)*dt*30, 0, 1)
		points[i] = (points[i] + inertia[i]*dt*60)%1024
		points[i+1] = (points[i+1] + inertia[i+1]*dt*60)%1024
	end
end,
draw = function()
	local depth = settings.bgsettings.depth or 4
	lg.setCanvas(snowcanvas)
	lg.clear()
	lg.points(points)
	lg.setCanvas(canvas.main)
	for i = 1,depth do
		--lg.setColor(255-i*127/depth,255-i*127/depth,255-i*127/depth)
		lg.setColor(1-i*0.5/depth,1-i*0.5/depth,1-i*0.5/depth)
		lg.draw(snowcanvas, quad[i], 0, 0, 0, 2/(i*.5))
	end
	lg.setColor(1,1,1)
end,
resize = function(w,h)
	local depth = settings.bgsettings.depth or 4
	quad = {}
	--for i = 1,4 do quad[i] = lg.newQuad(0, 0, w/(i/2), h/(i/2), 1024, 1024) end
	local scale = min(screen.w/512, screen.h/512)

	local w2, h2 = screen.w*scale, screen.h*scale

	for i = 1,depth do
		quad[i] = lg.newQuad(
			i*300, 0, -- add to X coord for some extra randomization
			w2/(2/(i*.5))/scale, h2/(2/(i*.5))/scale,
			1024*scale, 1024*scale
		)
	end
end,
menuitems = {
	{
		text = "Snowflakes",
		init = function(self)
			if settings.bgsettings.snowflakes then
				self.selected = getindex(self.options, settings.bgsettings.snowflakes)
			else
				settings.bgsettings.snowflakes = self.options[self.selected]
			end
		end,
		onchange = function(self)
			settings.bgsettings.snowflakes = self.options[self.selected]
			points = {}
			inertia = {}
			for i = 1,settings.bgsettings.snowflakes do
				table.insert(points, math.random(1,1024))
				table.insert(points, math.random(1,1024))
				table.insert(inertia, 0)
				table.insert(inertia, 0)
			end
		end,
		selected = 1,
		options = {256,512,1024,2048,4096,8192, 8, 64, 128},
	},
	{
		text = "Depth",
		init = function(self)
			if settings.bgsettings.depth then
				self.selected = getindex(self.options, settings.bgsettings.depth)
			else
				settings.bgsettings.depth = self.options[self.selected]
			end
		end,
		onchange = function(self)
			settings.bgsettings.depth = self.options[self.selected]
			genquad()
		end,
		selected = 1,
		options = {4,5,6,7,8,1,2,3},
	},
	{
		text = "Scale",
		init = function(self)
			local p = getindex(self.options, settings.bgsettings.scale)
			if not p then p = 1 end
			self.selected = p
			self.onchange(self)
		end,
		onchange = function(self)
			settings.bgsettings.scale = self.options[self.selected]
			genquad()
		end,
		selected = 1,
		options = {1,2,3,4},
	},
	{
		text = "Filtering",
		init = function(self)
			local p = getindex(self.options, settings.bgsettings.filtering)
			if not p then p = 1 end
			self.selected = p
			self.onchange(self)
		end,
		onchange = function(self)
			settings.bgsettings.filtering = self.options[self.selected]
			snowcanvas:setFilter(settings.bgsettings.filtering, settings.bgsettings.filtering)
		end,
		selected = 1,
		options = {"nearest", "linear"},
		options_text = {"Nearest", "Linear"},
	},
},
}