savegame = function()
	love.filesystem.write("savedata", serial.pack(settings))
end

if exists("savedata") then
	local f = love.filesystem.read("savedata")
	if f == "crash" then
		warning.push("Game crashed, save data cleared!")
		f = ""
	end
	settings = serial.unpack(f)
end
-- check sanity
if type(settings) ~= "table" then settings = {} end

local check = function(s,v)
	-- TODO check type to make sure it matches
	-- TODO make this more recursive
	if settings[s] == nil then
		--printd(s .. " = " .. v)
		settings[s] = v
	elseif type(v) == "table" then
		--printd(s)
		if settings[s] == nil then
			settings[s] = v
		else
			for i,k in pairs(v) do
				--printd("\t" .. i .. " = " .. tostring(k))
				if settings[s][i] == nil then
					settings[s][i] = k
				end
			end
		end
	--else
		--printd(s .. " = " .. tostring(v))
	end
end

check("conf", {
	lockreset = "none",
	lockdelay_soft = 20,
	randomizer = "modern",
	clear_delay = 20,
	ghost = true,
	scoring = "modern",
	lockdelay = 60,
	delete_above_field = true,
	allow_above_field = true,
	levels = "nes",
	kicks = "permissive",
	das_delay = 8,
	ARE = 0,
	harddrop = true,
	softdrop = true,
	spinny = true,
	smoothfall = "early",
	smoothslide = 0,
	softdrop_delay = 8,
	next = true,
	piece_sfx = "city",
	das_period = 3,
	gameover_check = "oncollision",
	softlock = false,
	hold = true,
	rot_system = "srs",
	softdrop_period = 2,
	piece_gfx = "city",
})
check("game", "minobueno")
check("style", "city")
check("music", {
	enabled = true,
	album = "Remixes",
	song = "Dance of the Sugar Plum Fairy",
	autoseek=true
})

if love.system.getOS() == "Android" then
	check("gfx", {
		lowlatency = false,
		showfps = false,
		fullscreen = true,
		intscale = false,
		aspectcorrect = true,
		pixelshader = false,
	})
else
	check("gfx", {
		lowlatency = true,
		showfps = false,
		fullscreen = false,
		intscale = false,
		aspectcorrect = true,
		pixelshader = true,
	})
end

check("sfx", true)
check("stylesfx", true)
if love.system.getOS() == "Android" then
	check("touch", true)
else
	check("touch", false)
end
check("bg","snow")
check("bgsettings", {})
check("stylesettings", {})
check("window", {w=800,h=600})
check("gamebg",true)

-- TODO silently fix these instead of erroring
local check = function(s) if not exists(s) then error(s .. " does not exist!") end end
check("/games/" .. settings.game .. "/game.lua")
check("/games/" .. settings.game .. "/style/" .. settings.style .. "/script.lua")
check("/menu/bg/" .. settings.bg .. "/main.lua")