local wasplaying = {sfx = {}, style = {}}

function playsfx(effect, stop)
	if sfx[effect] ~= nil and settings.sfx then
		if stop then
			sfx[effect]:stop()
		else
			sfx[effect]:seek(0)
			sfx[effect]:play()
			return true
		end
	end
	return false
end

function playstylesfx(effect, stop)
	if style.sfx[effect] ~= nil and settings.stylesfx then
		if settings.sfx then
			if stop then
				style.sfx[effect]:stop()
			else
				style.sfx[effect]:seek(0)
				style.sfx[effect]:play()
			end
		end
	else return false
	end  return true
end

-- run empty to stop all, send string to stop specific
function stopsfx(str)
	if sfx then
		if str == nil then
			for i in pairs(sfx) do sfx[i]:stop() end
			wasplaying.sfx = {}
		elseif sfx[str] then
			sfx[str]:stop()
		end
	end
end
function stopstylesfx(str)
	if style.sfx then
		if str == nil then
			for i in pairs(style.sfx) do style.sfx[i]:stop() end
			wasplaying.style = {}
		elseif style.sfx[str] then
			style.sfx[str]:stop()
		end
	end
end

-- unlike above, only pauses/resumes all, because that's all I've needed so far
function pausesfx()
	wasplaying.sfx = {}
	for i in pairs(sfx) do
		if sfx[i]:isPlaying() then
			wasplaying.sfx[i] = true
			sfx[i]:pause()
		end
	end
end
function pausestylesfx()
	wasplaying.style = {}
	for i in pairs(style.sfx) do
		if style.sfx[i]:isPlaying() then
			wasplaying.style[i] = true
			style.sfx[i]:pause()
		end
	end
end

function resumesfx()
	for i in pairs(wasplaying.sfx) do
		sfx[i]:play()
	end
end
function resumestylesfx()
	for i in pairs(wasplaying.style) do
		style.sfx[i]:play()
	end
end

function stopmusic()
	if music.source then music.source:stop() end
	if music.source_fast then music.source_fast:stop() end
end

function updatemusic(mus, fast, newalbum)
	--if state ~= "game" then return end
	mus = mus or settings.music.song
	if mus ~= settings.music.song or not music.source or newalbum then
		settings.music.song = mus
		if music.source then music.source:stop() end
		if music.source_fast then music.source_fast:stop() end

		local dir = "music/" .. settings.music.album .. "/" .. settings.music.song
		local extension = "flac"
		if exists(dir .. "/main.s3m") then
			extension = "s3m"
		elseif exists(dir .. "/main.ogg") then
			extension = "ogg"
		end

		music.source = love.audio.newSource(dir .. "/main." .. extension, "stream")
		if exists(dir .. "/fast." .. extension) then
			music.source_fast = love.audio.newSource(dir .. "/fast." .. extension, "stream")
		else
			music.source_fast = false
		end
		music.source:setLooping(true)
		if music.source_fast then
			music.source_fast:setLooping(true)
			music.fastspeed = music.source_fast:getDuration()/music.source:getDuration()
		end
	end
	if fast and not music.isfast and music.source_fast then
		local pos = music.source:tell()
		music.source:stop()
		if music.source_fast then
			music.source_fast:play()
			if settings.music.autoseek then
				music.source_fast:seek(pos*music.fastspeed)
			end
		end
		music.isfast = true
	elseif not fast and music.isfast and music.source_fast then
		local pos = music.source_fast:tell()
		music.source_fast:stop()
		music.source:play()
		if settings.music.autoseek then
			music.source:seek(pos/music.fastspeed)
		end
		music.isfast = false
	elseif music.isfast and music.source_fast then
		music.source_fast:play()
	else
		music.source:play()
	end
	if not settings.music.enabled then
		music.source:setVolume(0)
		if music.source_fast then music.source_fast:setVolume(0) end
	end
end